// eslint-disable-next-line import/no-extraneous-dependencies
import React, { useContext, useEffect, useState } from 'react';
import cs from 'classnames';
import { VALID_MESSAGE_TYPE_FROM_PARENT_WINDOW } from "../../../constants";
import { PreviewContext } from "../../../preview/previewContext";
import styles from "./tabs.module.scss";
export function Tabs({
  panes = []
}) {
  const {
    pubsub,
    pubsubTopic,
    pubsubTopicParent
  } = useContext(PreviewContext);
  const [activeKey, setActiveKey] = useState('0');
  useEffect(() => {
    pubsub === null || pubsub === void 0 ? void 0 : pubsub.reportActiveTab(pubsubTopic, {
      activeTab: `${activeKey}`
    });
  }, [activeKey]);
  useEffect(() => {
    pubsub === null || pubsub === void 0 ? void 0 : pubsub.sub(pubsubTopicParent, message => {
      const {
        type,
        data
      } = message;
      if (type === VALID_MESSAGE_TYPE_FROM_PARENT_WINDOW.switchActiveTab && data.tab) {
        setActiveKey(data.tab);
      }
    });
  }, [pubsub]);
  return /*#__PURE__*/React.createElement("div", {
    className: styles.tabs
  }, /*#__PURE__*/React.createElement("div", {
    className: styles.header
  }, panes.map(({
    title
  }, index) => {
    const isActive = index.toString() === activeKey;
    return /*#__PURE__*/React.createElement("div", {
      key: index,
      title: typeof title === 'string' ? title : undefined,
      className: cs(styles.title, {
        [styles.active]: isActive
      }),
      onClick: () => setActiveKey(index.toString())
    }, title);
  })), /*#__PURE__*/React.createElement("div", null, panes.map(({
    content
  }, index) => {
    const isActive = index.toString() === activeKey;
    return isActive ? /*#__PURE__*/React.createElement("div", {
      key: index
    }, content) : null;
  })));
}