import _extends from "@babel/runtime/helpers/extends";
import _defineProperty from "@babel/runtime/helpers/defineProperty";
import _objectWithoutProperties from "@babel/runtime/helpers/objectWithoutProperties";
const _excluded = ["children", "components", "className"];
function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { _defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
// eslint-disable-next-line import/no-extraneous-dependencies
import React, { useMemo } from 'react';
import { MDXProvider } from '@mdx-js/react';
import classNames from 'classnames';
import { DEFAULT_MDX_COMPONENTS } from "../components";

// use markdown-limit.css, not markdown.css
import "../style/markdown-limit.css";
import styles from "./mdxLayout.module.scss";
const MARKDOWN_BODY_CLASSNAME = 'markdown-body';
/** Arco flavored MDX theme */
export function MDXLayout(_ref) {
  let {
      children,
      components,
      className
    } = _ref,
    rest = _objectWithoutProperties(_ref, _excluded);
  const _components = useMemo(() => {
    // add classname 'markdown-element' to these markdown elements
    // then we can apply css styles to them
    const tagNames = ['a', 'abbr', 'b', 'button', 'code', 'dfn', 'em', 'figure', 'hr', 'img', 'input', 'kbd', 'li', 'mark', 'ol', 'p', 'samp', 'small', 'span', 'strong', 'sub', 'summary', 'sup', 'table', 'td', 'th', 'tr', 'ul'];
    const interExtendedComponents = {};
    tagNames.forEach(tag => {
      if (typeof tag === 'string') {
        interExtendedComponents[tag] = props => {
          return /*#__PURE__*/React.createElement(tag, _objectSpread(_objectSpread({}, props), {}, {
            className: classNames(props.className, 'a-md-element')
          }));
        };
      }
    });
    return _objectSpread(_objectSpread(_objectSpread({}, interExtendedComponents), DEFAULT_MDX_COMPONENTS), components);
  }, [DEFAULT_MDX_COMPONENTS, components]);
  return /*#__PURE__*/React.createElement(MDXProvider, {
    components: _components
  }, /*#__PURE__*/React.createElement("div", _extends({
    className: classNames(MARKDOWN_BODY_CLASSNAME, styles.mdxContent, className)
  }, rest), children));
}