export class SlotRegister {
  constructor(map = new Map()) {
    this.map = map;
  }
  get(id) {
    return this.map.get(id);
  }
  toArray() {
    return Array.from(this.map.entries());
  }
  values() {
    return Array.from(this.map.values());
  }
  unregister(id) {
    this.map.delete(id);
  }
  register(cb) {
    const id = Math.random().toFixed(8).slice(2);
    this.map.set(id, cb);
    return () => this.unregister(id);
  }
}