import _defineProperty from "@babel/runtime/helpers/defineProperty";
function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { _defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
// eslint-disable-next-line import/no-extraneous-dependencies
import React, { useEffect, useMemo, useRef, useState } from 'react';
// eslint-disable-next-line import/no-extraneous-dependencies
import { createPortal } from 'react-dom';
import { Table } from "../../baseUI/table";
import { CodeSnippet } from "../../markdown/components/snippet/codeSnippet";
import styles from "./propertiesTable.module.scss";
export function PropertiesTable({
  doclet,
  placeholderID
}) {
  const [, forceUpdate] = useState(0);
  const refPortal = useRef(null);
  const anchorList = useMemo(() => {
    const list = [];
    if (doclet !== null && doclet !== void 0 && doclet.length) {
      const apiTitleText = 'API';
      list.push({
        text: apiTitleText,
        depth: 1,
        content: /*#__PURE__*/React.createElement("h1", {
          id: apiTitleText,
          key: apiTitleText
        }, apiTitleText)
      });
      list.push(...doclet.map(({
        name,
        type,
        properties
      }, index) => ({
        text: name,
        depth: 2,
        content: /*#__PURE__*/React.createElement("div", {
          key: index,
          className: styles.table
        }, /*#__PURE__*/React.createElement("h2", {
          id: name,
          className: styles.tableTitle
        }, name), type ? /*#__PURE__*/React.createElement(CodeSnippet, {
          children: type
        }) : null, properties.length ? /*#__PURE__*/React.createElement(Table, {
          headings: ['name', 'type', 'default', 'description'],
          rows: properties.map(p => _objectSpread(_objectSpread({}, p), {}, {
            default: p.defaultValue
          }))
        }) : null)
      })));
    }
    return list;
  }, [doclet]);
  const eleTable = anchorList.length ? /*#__PURE__*/React.createElement("div", {
    className: styles.propertiesTable
  }, anchorList.map(({
    content
  }) => content)) : null;
  useEffect(() => {
    if (!placeholderID) return undefined;
    const observer = new MutationObserver(() => {
      const placeholder = document.querySelector(`#${placeholderID}`);
      if (placeholder) {
        refPortal.current = /*#__PURE__*/createPortal(eleTable, placeholder);
        forceUpdate(Math.random());
      }
    });
    observer.observe(document.body, {
      childList: true,
      subtree: true
    });
    return () => {
      observer.disconnect();
    };
  }, [placeholderID]);
  return placeholderID ? refPortal.current : eleTable;
}