// eslint-disable-next-line import/no-extraneous-dependencies
import React, { createContext, useEffect, useMemo, useRef } from 'react';
const GLOBAL_MAP_KEY = '__ARCO_PREVIEW_GLOBAL_VARIABLES';
export const PreviewContext = /*#__PURE__*/createContext({
  registerGlobalVariable: () => {}
});
export function PreviewContextProvider(props) {
  const {
    children,
    pubsub,
    pubsubTopic,
    pubsubTopicParent
  } = props;
  const refGlobalVariablesMap = useRef({
    // this is the version for preview App
    parentMessageIsSubscribed: true
  });
  useEffect(() => {
    window[GLOBAL_MAP_KEY] = refGlobalVariablesMap.current;
  }, []);
  const previewContextValue = useMemo(() => {
    return {
      pubsub,
      pubsubTopic,
      pubsubTopicParent,
      registerGlobalVariable: (name, fn) => {
        refGlobalVariablesMap.current[name] = fn;
      }
    };
  }, []);
  return /*#__PURE__*/React.createElement(PreviewContext.Provider, {
    value: previewContextValue
  }, children);
}